

local o = AbilityLinksMonitor1; if (o.SHOULD_LOAD == nil) then return; end


local l_t_Init; -- ()
local l_t_GetLocals; -- linksTable = ()
local l_t_UnregisterForAllEvents; -- ()

local l_OnEvent_ChatLinksMonitor1_LINKS_FOUND; -- (linksTable, source)
local l_OnEvent_INSPECT_TALENT_READY; -- ()
local l_OnEvent_LEARNED_SPELL_IN_TAB; -- ()
local l_OnEvent_PLAYER_LOGIN; -- ()

local l_DispatchLinks; -- (linksTable, source)

local l_ParseSpellbook; -- (linksTable)
local l_ParseTalents; -- (linksTable, isInspect)
local l_t_ParseBrute; -- (linksTable, minID, maxID)


local GetSpellLink = GetSpellLink; -- ParseSpellbook, t_ParseBrute


local l_linksTable;


do
	if (o.t_GetLocals ~= nil) then
		l_linksTable = o.t_GetLocals();
	else
		l_linksTable = {};
	end
end




function l_t_Init()
	l_t_Init = nil;
	o.t_Init = nil;
	
	local em = EventsManager1;
	em.AddCustomEvent("AbilityLinksMonitor1_LINKS_FOUND", false);
	
	if (o.t_UnregisterForAllEvents ~= nil) then
		o.t_UnregisterForAllEvents();
	end
	o.t_UnregisterForAllEvents = l_t_UnregisterForAllEvents;
	
	local RFE = em.RegisterForEvent;
	RFE(l_OnEvent_ChatLinksMonitor1_LINKS_FOUND, nil, "ChatLinksMonitor1_LINKS_FOUND", false, false);
	RFE(l_OnEvent_INSPECT_TALENT_READY, nil, "INSPECT_TALENT_READY", false, false);
	RFE(l_OnEvent_LEARNED_SPELL_IN_TAB, nil, "LEARNED_SPELL_IN_TAB", false, false);
	if (IsLoggedIn() ~= nil) then
		l_OnEvent_PLAYER_LOGIN();
	else
		RFE(l_OnEvent_PLAYER_LOGIN, nil, "PLAYER_LOGIN", false, false);
	end
end

o.t_Init = l_t_Init;



function l_t_GetLocals()
	l_t_GetLocals = nil;
	o.t_GetLocals = nil;
	
	return l_linksTable;
end

o.t_GetLocals = l_t_GetLocals;



function l_t_UnregisterForAllEvents()
	l_t_UnregisterForAllEvents = nil;
	o.t_UnregisterForAllEvents = nil;
	
	local UFE = o.EventsManager1.UnregisterForEvent;
	UFE(l_OnEvent_ChatLinksMonitor1_LINKS_FOUND, "ChatLinksMonitor1_LINKS_FOUND");
	UFE(l_OnEvent_INSPECT_TALENT_READY, "INSPECT_TALENT_READY");
	UFE(l_OnEvent_LEARNED_SPELL_IN_TAB, "LEARNED_SPELL_IN_TAB");
	if (l_OnEvent_PLAYER_LOGIN ~= nil) then UFE(l_OnEvent_PLAYER_LOGIN, "PLAYER_LOGIN"); end
end




do
	local pairs = pairs;
	local stringsub = string.sub;
	
	function l_OnEvent_ChatLinksMonitor1_LINKS_FOUND(linksTable, source)
		local arrayIndex = #l_linksTable;
		for index, link in pairs(linksTable) do
			if (stringsub(link, 13, 18) == "spell:") then
				arrayIndex = (arrayIndex + 1);
				l_linksTable[arrayIndex] = link;
			end
		end
		l_DispatchLinks(l_linksTable, ("chat-" .. source));
	end
end



function l_OnEvent_INSPECT_TALENT_READY()
	l_ParseTalents(l_linksTable, true);
	l_DispatchLinks(l_linksTable, "talent-inspect");
end



function l_OnEvent_LEARNED_SPELL_IN_TAB()
	l_ParseSpellbook(l_linksTable);
	l_DispatchLinks(l_linksTable, "spellbook");
end



function l_OnEvent_PLAYER_LOGIN()
	l_OnEvent_PLAYER_LOGIN = nil;
	
	-- As of Apr 1, 2008, the highest ID seems to be 47653.
	-- This was found via /script local h = 0; for i = 1, 50000, 1 do if (GetSpellLink(i)) then h = i; end end ChatFrame1:AddMessage(h);
	local linksTable = {};
	l_t_ParseBrute(linksTable, 1, 49000);
	l_DispatchLinks(linksTable, "brute");
	
	l_ParseSpellbook(l_linksTable);
	l_DispatchLinks(l_linksTable, "spellbook");
	l_ParseTalents(l_linksTable, false);
	l_DispatchLinks(l_linksTable, "talent-player");
end




function l_DispatchLinks(linksTable, source)
	if (#linksTable == 0) then return; end
	
	o.EventsManager1.DispatchEvent("AbilityLinksMonitor1_LINKS_FOUND", linksTable, source);
	
	for index = #linksTable, 1, -1 do
		linksTable[index] = nil;
	end
end




function l_ParseSpellbook(linksTable)
	local link;
	local arrayIndex = #linksTable;
	
	local index = 1;
	link = GetSpellLink(1, "spell");
	while (link ~= nil) do
		arrayIndex = (arrayIndex + 1);
		linksTable[arrayIndex] = link;
		index = (index + 1);
		link = GetSpellLink(index, "spell");
	end
	
	local index = 1;
	link = GetSpellLink(1, "pet");
	while (link ~= nil) do
		arrayIndex = (arrayIndex + 1);
		linksTable[arrayIndex] = link;
		index = (index + 1);
		link = GetSpellLink(index, "pet");
	end
end



do
	local GetTalentLink = GetTalentLink;
	
	function l_ParseTalents(linksTable, isInspect)
		isInspect = ((isInspect and true) or false);
		local link;
		local arrayIndex = #linksTable;
		
		local subIndex;
		for index = 3, 1, -1 do
			subIndex = 1;
			link = GetTalentLink(index, 1, isInspect);
			while (link ~= nil) do
				arrayIndex = (arrayIndex + 1);
				linksTable[arrayIndex] = link;
				subIndex = (subIndex + 1);
				link = GetTalentLink(index, subIndex, isInspect);
			end
		end
	end
end




function l_t_ParseBrute(linksTable, minID, maxID)
	l_t_ParseBrute = nil;
	
	local link;
	local arrayIndex = #linksTable;
	
	for index = minID, maxID, 1 do
		link = GetSpellLink(index);
		if (link ~= nil) then
			arrayIndex = (arrayIndex + 1);
			linksTable[arrayIndex] = link;
		end
	end
end

